Sketcher SketchObject: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
Line 13: Line 13:


<!--T:3-->
<!--T:3-->
The {{incode|Sketcher::SketchObject}} is derived from [[Part_Part2DObject|Part Part2DObject]], which means it is a [[Part Feature|Part Feature]] object specialized for 2D geometry. Like Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints of the lines and curves that are drawn within it.
The {{incode|Sketcher::SketchObject}} is derived from the [[Part_Part2DObject|Part Part2DObject]], which means it is a [[Part Feature|Part Feature]] object specialized for 2D geometry. Like the Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints.


<!--T:23-->
<!--T:23-->
Line 19: Line 19:


<!--T:24-->
<!--T:24-->
{{Caption|Simplified diagram of the relationships between the core objects in FreeCAD. The {{incode|Sketcher::SketchObject}} class is specialized for 2D shapes, and additionally it includes an extension to handle geometrical constraints of its elements.}}
{{Caption|Simplified diagram of the relationships between the core objects in FreeCAD}}


==Usage== <!--T:4-->
==Usage== <!--T:4-->
Line 30: Line 30:


<!--T:6-->
<!--T:6-->
Although the SketchObject can be used by itself to draw on a plane, it is most commonly used in conjunction with the [[PartDesign Workbench|PartDesign Workbench]] to create extruded solids.
Although the SketchObject can be used by itself to draw on a plane, it is most commonly used in conjunction with the [[PartDesign_Workbench|PartDesign Workbench]] to create extruded solids.


<!--T:7-->
<!--T:7-->
# Switch to the [[PartDesign Workbench|PartDesign Workbench]].
# Switch to the [[PartDesign_Workbench|PartDesign Workbench]].
# Press {{Button|[[File:PartDesign_Body.svg|16px]] [[PartDesign_Body|PartDesign Body]]}}.
# Press {{Button|[[File:PartDesign_Body.svg|16px]] [[PartDesign_Body|PartDesign Body]]}}.
# Press {{Button|[[File:PartDesign_NewSketch.svg|16px]] [[PartDesign_NewSketch|PartDesign NewSketch]]}}.
# Press {{Button|[[File:PartDesign_NewSketch.svg|16px]] [[PartDesign_NewSketch|PartDesign NewSketch]]}}.
Line 70: Line 70:


* {{PropertyView|Grid Auto Size|Bool|Hidden}}: if {{TRUE}} the grid is resized based on the boundingbox of the geometry of the sketch.
* {{PropertyView|Grid Auto Size|Bool|Hidden}}: if {{TRUE}} the grid is resized based on the boundingbox of the geometry of the sketch.
* {{PropertyView|Grid Size|Length}}: the size of the spacing of the local grid lines in the [[3D view|3D view]]; it defaults to {{value|10 mm}}.
* {{PropertyView|Grid Size|Length}}: the size of the spacing of the local grid lines in the [[3D_view|3D view]]; it defaults to {{value|10 mm}}.
* {{PropertyView|Grid Snap|Bool}}: if {{TRUE}} the grid can be used to snap points.
* {{PropertyView|Grid Snap|Bool}}: if {{TRUE}} the grid can be used to snap points.
* {{PropertyView|Grid Style|Enumeration}}: the style of the grid lines; {{value|Dashed}} (default) or {{value|Light}}.
* {{PropertyView|Grid Style|Enumeration}}: the style of the grid lines; {{value|Dashed}} (default) or {{value|Light}}.
* {{PropertyView|Show Grid|Bool}}: if {{TRUE}} a grid local to the object will be displayed in the [[3D view|3D view]]. This grid is independent of the [[Draft_ToggleGrid|Draft Grid]].
* {{PropertyView|Show Grid|Bool}}: if {{TRUE}} a grid local to the object will be displayed in the [[3D_view|3D view]]. This grid is independent of the [[Draft_ToggleGrid|Draft Grid]].
* {{PropertyView|Show Only In Edit Mode|Bool}}: if {{TRUE}} the grid is only displayed while the sketch is being edited.
* {{PropertyView|Show Only In Edit Mode|Bool}}: if {{TRUE}} the grid is only displayed while the sketch is being edited.
* {{PropertyView|Tight Grid|Bool}}: if {{TRUE}} the local grid will be localized around the origin of the shape, otherwise it will extend itself more.
* {{PropertyView|Tight Grid|Bool}}: if {{TRUE}} the local grid will be localized around the origin of the shape, otherwise it will extend itself more.
Line 93: Line 93:


<!--T:19-->
<!--T:19-->
See also: [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]] and [[Scripted_objects|scripted objects]].
{{Emphasis|See also:}} [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]] and [[Scripted_objects|scripted objects]].


<!--T:20-->
<!--T:20-->

Revision as of 07:40, 22 February 2022

Introduction

A Sketcher SketchObject, or formally a Sketcher::SketchObject, is the base element to create 2D objects with the Sketcher Workbench.

The Sketcher::SketchObject is derived from the Part Part2DObject, which means it is a Part Feature object specialized for 2D geometry. Like the Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints.

Simplified diagram of the relationships between the core objects in FreeCAD

Usage

  1. Switch to the Sketcher Workbench.
  2. Press Sketcher NewSketch.
  3. Select a Sketch orientation: XY-plane, XZ-plane, or YZ-plane. Optionally also choose Reverse direction, and give an Offset value.
  4. Press OK.

Although the SketchObject can be used by itself to draw on a plane, it is most commonly used in conjunction with the PartDesign Workbench to create extruded solids.

  1. Switch to the PartDesign Workbench.
  2. Press PartDesign Body.
  3. Press PartDesign NewSketch.
  4. Select feature: XY_Plane (Base plane), XZ_Plane (Base plane), or YZ_Plane (Base plane).
  5. Press OK.

Properties

See Property for all property types that scripted objects can have.

The Sketcher SketchObject (Sketcher::SketchObject class) is derived from the Part Part2DObject (Part::Part2DObject class) and inherits all its properties.

The Sketcher SketchObject also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Sketch

  • Data (Hidden)Geometry (GeometryList): a list of Part geometries that exist inside the sketch.
  • DataConstraints: named constraints, if they exist; otherwise it is an empty list [].
  • DataExternal Geometry (LinkSubList): a list of Part geometries outside this Sketch that are used for reference.
  • Data (Hidden)Fully Constrained (Bool): (read-only) if true the sketch is fully constrained.

View

Auto Constraints

  • ViewAutoconstraints (Bool): if true constraints are automatically added when geometry is drawn.
  • ViewAvoid Redundant (Bool): if true redundant auto-constraints are avoided.

Grid

  • View (Hidden)Grid Auto Size (Bool): if true the grid is resized based on the boundingbox of the geometry of the sketch.
  • ViewGrid Size (Length): the size of the spacing of the local grid lines in the 3D view; it defaults to 10 mm.
  • ViewGrid Snap (Bool): if true the grid can be used to snap points.
  • ViewGrid Style (Enumeration): the style of the grid lines; Dashed (default) or Light.
  • ViewShow Grid (Bool): if true a grid local to the object will be displayed in the 3D view. This grid is independent of the Draft Grid.
  • ViewShow Only In Edit Mode (Bool): if true the grid is only displayed while the sketch is being edited.
  • ViewTight Grid (Bool): if true the local grid will be localized around the origin of the shape, otherwise it will extend itself more.
  • Viewmax Number Of Lines (Integer): the maximum number of lines in the grid.

Visibility automation

  • ViewEditing Workbench (String): name of the workbench to activate when editing the sketch; it defaults to SketcherWorkbench.
  • ViewForce Ortho (Bool): if true the camera will be forced to orthographic view mode when the sketch is opened.
  • ViewHide Dependent (Bool): if true all objects that depend on the sketch are hidden when the sketch is opened.
  • ViewRestore Camera (Bool): if true the camera position is saved before opening the sketch, and is restored after closing it.
  • ViewSection View (Bool): if true only (parts of) objects behind the sketch plane are visible while the sketch is being edited.
  • ViewShow Links (Bool): if true all objects used in links to external geometry are shown when the sketch is opened.
  • ViewShow Support (Bool): if true all objects this sketch is attached to are shown when the sketch is opened.
  • View (Hidden)Tempo Vis (PythonObject): a custom class associated with this object, that handles hiding and showing other objects when opening and closing the sketch.

Scripting

See also: FreeCAD Scripting Basics and scripted objects.

See Part Feature for the general information on adding objects to the document.

A SketchObject is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Sketch")
obj.Label = "Custom label"

For Python subclassing you should create the Sketcher::SketchObjectPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObjectPython", "CustomSketch")
obj.Label = "Custom label"